#include <Wt/WApplication>
#include <Wt/WContainerWidget>
#include <Wt/WGoogleMap>
#include <Wt/WGridLayout>
#include <Wt/WSlider>

class ShortSliderApplication : public Wt::WApplication
{
  public:

    ShortSliderApplication (Wt::WEnvironment const & wEnvironment)
      : Wt::WApplication (wEnvironment)
    {
      setTitle ("short-slider example");
      setCssTheme ("polished");

      class WSlider : public Wt::WSlider
      {
        public:

          WSlider (Wt::Orientation const orientation)
            : Wt::WSlider (orientation)
          {
            setMinimum (0);
            setMaximum (100);
            setTickInterval (10);
            setTickPosition (Wt::WSlider::TicksBothSides);
          }
      };

      class WContainerWidget : public Wt::WContainerWidget
      {
        public:

          WContainerWidget ()
          {
            Wt::WGridLayout * const layout = new Wt::WGridLayout ();

            layout->addWidget (new WSlider (Wt::Horizontal), 0, 1, 1, 1);
            layout->addWidget (new WSlider (Wt::Vertical), 1, 0, 1, 1);
            layout->addWidget (new Wt::WGoogleMap (), 1, 1, 1, 1);
            layout->setRowStretch (1, 1);
            layout->setColumnStretch (1, 1);
            setLayout (layout);
            setMinimumSize (800, 600);
            setMaximumSize (800, 600);
          }
      };

      root ()->addWidget (new WContainerWidget ());
    }
};

Wt::WApplication * createApplication (Wt::WEnvironment const & wEnvironment)
{
  std::cout << "ahhol" << std::endl;
  return new ShortSliderApplication (wEnvironment);
}

int main (int argc, char ** argv)
{
  return WRun (argc, argv, &createApplication);
}

